#include "drawlabel.h"

DrawLabel::DrawLabel(QWidget *parent) : QLabel(parent)
{
    enableParabola = false;
    noOfPoints = 0;
    parabolaPoints = new QPointF[1000];
    measPoints = new QPointF[50];
    m_yscale=20;
    m_xscale=10000;
    measPointCount = 0;
}

void DrawLabel::drawParabola()
{
//    qDebug() << "draw parabola" << endl;
//    qDebug() << "a:" << a << " b: " << b << " c:" << c << endl;

    for (int i=0;i<1000;i++) {
        double x,y;

        x=((double)i)*0.5/1000.0;
        y = -(a*x*x - 2.0*a*b*x + a*b*b+c);
        parabolaPoints[i].setX(x*m_xscale);
        parabolaPoints[i].setY(y*m_yscale);
    }
    for (int i=0; i<10;i++)
    qDebug() << parabolaPoints[i].x() << " " << parabolaPoints[i].y() ;
}

void DrawLabel::defineMeasPoint(QPointF measPoint)
{
    measPoints[measPointCount] = measPoint;
    measPointCount++;
}

void DrawLabel::clearMeasPoints()
{
    measPointCount=0;
}

void DrawLabel::paintEvent(QPaintEvent *)
{
    QPainter paint(this);
    qDebug() << "update" << endl;
    QMatrix m;
    QLine invertedLine;
    QPoint point;
    paint.eraseRect(10,10,410,410);

    paint.setPen(QColor(Qt::black));
    QPoint transOffs = QPoint(10,400);
    paint.translate(transOffs);
    paint.scale(1,1);

    // draw the axis
    // horizontal
    paint.drawLine(0,0,400,0);
    for (int i=1; i<8; i++)
        paint.drawLine(50*i,-2,50*i,2);
// vertical
    paint.drawLine(0,10,0,-400);
    for (int i=1; i<8; i++)
        paint.drawLine(-2,-50*i,2,-50*i);

    if (enableParabola) {
//        qDebug() << "parabola enabled" << endl;
        paint.setPen(QColor(Qt::green));
        for (int i=0;i<199;i++)
            paint.drawLine(parabolaPoints[i],parabolaPoints[i+1]);
    }
//    else
//        qDebug() << "parabola disabled" << endl;
    QPen pen = QPen();
    pen.setColor(QColor(Qt::blue));
    pen.setWidth(5);
    paint.setPen(pen);

    for (int i=0;i<measPointCount;i++) {
        qDebug() << "x " << measPoints[i].x() << " y " << measPoints[i].y() << endl;
        QPointF drawPoint;
        drawPoint.setX(measPoints[i].x()*m_xscale);
        drawPoint.setY(-measPoints[i].y()*m_yscale);
        paint.drawPoint(drawPoint);
        qDebug() << " Point " << drawPoint.x() << ", " << drawPoint.y() << endl;
    }
}
