#include "quadscan.h"
#include "ui_quadscan.h"

QuadScan::QuadScan(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::QuadScan)
{
    ui->setupUi(this);
    drawLabel = new DrawLabel((QWidget *)ui->frame);
    drawLabel->setGeometry(QRect(0, 0, 510, 510));
    drawLabel -> enableParabola = false;
    connect(ui->actionQuit, SIGNAL(triggered()),this,SLOT(fileQuit()));

    connect(ui->enableParabola, SIGNAL(stateChanged(int)),this,SLOT(enableParabola(int)));
    connect(ui->clearButton, SIGNAL(clicked()),this,SLOT(clearMeasPoints()));
    connect(ui->drawButton, SIGNAL(clicked()),this,SLOT(drawMeasPoint()));
    connect(ui->aSpin, SIGNAL(valueChanged(double)),this,SLOT(drawParabola()));
    connect(ui->bSpin, SIGNAL(valueChanged(double)),this,SLOT(drawParabola()));
    connect(ui->cSpin, SIGNAL(valueChanged(double)),this,SLOT(drawParabola()));
}

QuadScan::~QuadScan()
{
    delete ui;
}

void QuadScan::fileQuit()
{
    QCoreApplication::quit();
}
void QuadScan::clearMeasPoints()
{
    drawLabel -> clearMeasPoints();
    drawLabel -> update();
}

void QuadScan::drawMeasPoint()
{
    QPointF newPoint = QPointF(ui->quadStrength->value(),ui->profileWidth->value());
    drawLabel->defineMeasPoint(newPoint);
    drawLabel -> update();
}

void QuadScan::drawParabola()
{
    drawLabel -> a = ((ui->aSpin) -> value());
    drawLabel -> b = ((ui->bSpin) -> value());
    drawLabel -> c = ((ui->cSpin) -> value());
    drawLabel -> drawParabola();
    drawLabel -> update();
}

void QuadScan::enableParabola(int state)
{
//    qDebug() << "enableParabola" << endl;
    if (state == Qt::Checked)
        drawLabel -> enableParabola = true;
    else
        drawLabel -> enableParabola = false; 

  //  qDebug() << "draw parabola" << endl;
    drawLabel->drawParabola();
    drawLabel -> update();
}

